<?php

namespace Drupal\danse;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\danse\Entity\EventInterface;

/**
 * Interface for DANSE payload.
 */
interface PayloadInterface {

  /**
   * @return string
   */
  public function label(): string;

  /**
   * @return string
   */
  public function getEventReference(): string;

  /**
   * @param \Drupal\danse\Entity\EventInterface $event
   *
   * @return string[]
   */
  public function getSubscriptionReferences(EventInterface $event): array;

  /**
   * @return array
   */
  public function prepareArray(): array;

  /**
   * @param array $payload
   *
   * @return \Drupal\danse\PayloadInterface
   */
  public static function createFromArray(array $payload): PayloadInterface;

  /**
   * @return \Drupal\Core\Entity\ContentEntityInterface
   */
  public function getEntity(): ContentEntityInterface;

  /**
   * @param int $uid
   *
   * @return bool
   */
  public function hasAccess($uid): bool;

}
